      program make_input

      implicit NONE

      integer NBODMAX
      parameter (NBODMAX=201)

      integer nbod,ialpha,j,iseed
      real*8 ran3
      real*8 dpi,msun,gm,au
      real*8 radius,rhill,sema,ecc,inc,capom,omega,capm
      real*8 x,y,z,vx,vy,vz
      real*8 me,totmass,multiple,factor,rho
      real*8 tot,a_,mass_,q,q_
      real*8 mass(NBODMAX),a(NBODMAX)

      dpi=acos(-1.d0)
      msun=39.47841760d0  ! GM, au/y
      me=3.d-6*msun
      au=1.496d11  ! m

      read(*,*,err=990,end=990) iseed
      iseed = -iseed

c Mercury- to Mars-size protoplanets
      totmass = 2.d0*me
      multiple = 9.75d0
      factor = 1.0260d0
      a_ = 0.45d0
      mass_ = 0.05d0*me
      rho = 3.0d3  ! kg m^-3

      tot = 0.0
      j = 0

      do while ((tot.lt.totmass).and.(j.lt.NBODMAX))
        j = j+1
        mass(j) = mass_
        mass_ = mass(j)*factor
        q = mass(j)/msun
        q_ = mass_/msun
        a(j) = a_
        a_ = a(j)*(1.d0 + multiple*0.5d0*((q+q_)/3.d0)**(1.d0/3.d0)) /
     :    (1.d0 - multiple*0.5d0*((q+q_)/3.d0)**(1.d0/3.d0))
        tot = tot + mass(j)
      enddo

      nbod = j
      if (j.ge.NBODMAX) then
        write(*,*) 'Error: j = NBODMAX = ', NBODMAX
        stop
      endif

c Sun
      write(*,*)nbod+1
      write(*,8488)msun
 8488 format(3(1x,g20.10))    
      write(*,*)'0.0 0.0 0.0'
      write(*,*)'0.0 0.0 0.0'      

c no Jupiter

c protoplanets
      do j=1,nbod
        sema=a(j)
        rhill=sema*(mass(j)/(3.d0*msun))**(1.d0/3.d0)
        radius=(mass(j)/msun*2.d30/(4.d0/3.d0*dpi*rho))**(1.d0/3.d0)/au
c        write(*,*) 'sema = ', sema, ' au'
c        write(*,*) 'mass = ', mass(j)/me, ' M_E'
c        write(*,*) 'radius = ', radius, ' au = ', radius*au/1.e3, ' km'
        ecc=0.01d0
        inc=0.5d0/180.d0*dpi
        capom=ran3(iseed)*2.d0*dpi
        omega=ran3(iseed)*2.d0*dpi
        capm=ran3(iseed)*2.d0*dpi
        gm=msun+mass(j)
        ialpha=-1
        call orbel_el2xv(gm,ialpha,sema,ecc,inc,
     &       capom,omega,capm,x,y,z,vx,vy,vz)
        write(*,8488)mass(j),rhill,radius
        write(*,8488)x,y,z
        write(*,8488)vx,vy,vz
      end do

      stop

990   continue
      write(*,*) 'Error reading iseed.'
      end

c ===============================================================
      function ran3(idum)
      implicit real*8(a-h,o-z)
      parameter (mbig=1000000000,mseed=161803398,mz=0,fac=1.d-9)
      dimension ma(55)
      data iff /0/
      save
c --------------------------------------------------------------------
      if((idum.ge.0).and.(iff.ne.0)) goto 20
        iff=1
        mj=mseed-iabs(idum)
        mj=mod(mj,mbig)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.mz)mk=mk+mbig
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.mz)ma(i)=ma(i)+mbig
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
20    continue
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.mz)mj=mj+mbig
      ma(inext)=mj
      ran3=mj*fac
      return
      end

